-- Craft Research Timer (CRT) by @aTo (EU)
-- v0.4.8


function CRT_Research_Alert(k, id_craft, simcraft, start)
	if (start == true) then
		for i = 0, 2, 1 do
		local MaxResearch = CRT.SV.Craft_data[k][i]["MaxResearch"]
		local Simu_craft = CRT.SV.Craft_data[k][i]["Simu_craft"]
			if(Simu_craft < MaxResearch) then
					if (i == 0 and CRT.SV.Settings.ALERT.BS == true) then
						local msg = "Warning only "..Simu_craft.." / "..MaxResearch.." on Blacksmithing ( "..k.." )"
						CRT_ALERT_WD:AddMessage(msg, CRT.SV.Settings.ALERT.Color.r, CRT.SV.Settings.ALERT.Color.g, CRT.SV.Settings.ALERT.Color.b)
					elseif (i == 1 and CRT.SV.Settings.ALERT.CL == true) then
						local msg = "Warning only "..Simu_craft.." / "..MaxResearch.." on Clothing ( "..k.." )"
						CRT_ALERT_WD:AddMessage(msg, CRT.SV.Settings.ALERT.Color.r, CRT.SV.Settings.ALERT.Color.g, CRT.SV.Settings.ALERT.Color.b)
					elseif (i == 2 and CRT.SV.Settings.ALERT.WO == true) then
						local msg = "Warning only "..Simu_craft.." / "..MaxResearch.." on Woodworking ( "..k.." )"
						CRT_ALERT_WD:AddMessage(msg, CRT.SV.Settings.ALERT.Color.r, CRT.SV.Settings.ALERT.Color.g, CRT.SV.Settings.ALERT.Color.b)
					end
			end
		end
	else	
		
		
		-- UPDATE SIMU_CRAFT
			local MaxResearch = CRT.SV.Craft_data[k][id_craft]["MaxResearch"]
			local Simu_craft = CRT.SV.Craft_data[k][id_craft]["Simu_craft"] - 1 		-- set new simucraft
				CRT.SV.Craft_data[k][id_craft]["Simu_craft"] = Simu_craft 			-- save new simucraft
			if (id_craft == 0) then
				id_text = "BS_Text"
			elseif(id_craft == 1) then
				id_text = "CL_Text"				
			elseif(id_craft == 2) then
				id_text = "WO_Text"
			end
					
			CRT_GRID_WD[k][id_craft][0][id_text]:SetText(" "..Simu_craft.." / "..MaxResearch)
	
			local Item_name = CRT.SV.Craft_data[k][id_craft][simcraft]["Item_name"]
			local Trait_name = CRT.SV.Craft_data[k][id_craft][simcraft]["Trait_name"]
			local msg = "Reseach completed on "..k.."  ( "..Item_name.." - "..Trait_name.." )"
			CRT_ALERT_WD:AddMessage(msg,1,0,0)
	end		
end

function CRT_Alert_Create()
	CRT_ALERT_TLW = WINDOW_MANAGER:CreateTopLevelWindow("CRT_ALERT_TLW")
	CRT_ALERT_TLW:SetDimensions(800,300)
	CRT_ALERT_TLW:SetHidden(not CRT.SV.Settings.ALERT.hidden)
	CRT_ALERT_TLW:SetClampedToScreen(false)
	CRT_ALERT_TLW:SetMovable(CRT.SV.Settings.lock)
	CRT_ALERT_TLW:SetMouseEnabled(true)
	CRT_ALERT_TLW:SetDrawLayer(0)
	CRT_ALERT_TLW:SetScale(1)
	CRT_ALERT_TLW:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, CRT.SV.Settings.ALERT.offset.X, CRT.SV.Settings.ALERT.offset.Y)
	CRT_ALERT_TLW:SetHandler("OnMouseUp", function(self) CRT_Save_position("ALERT")end)
	
	--Text Buffer
	CRT_ALERT_WD = WINDOW_MANAGER:CreateControl("CRT_ALERT_WB",CRT_ALERT_TLW,CT_TEXTBUFFER)
	CRT_ALERT_WD:SetDimensions( 800, 300 )
	CRT_ALERT_WD:SetFont( "ZoFontGame" )
	CRT_ALERT_WD:SetAnchor(TOPLEFT,lsSum,TOPLEFT,0,0)
	CRT_ALERT_WD:SetLineFade(10,2)
	CRT_ALERT_WD:SetHorizontalAlignment(1)
	CRT_ALERT_WD:SetClearBufferAfterFadeout(true)
	--	CRT_ALERT_WB:SetLinkEnabled( true )
		
	CRT_ALERT_BD = WINDOW_MANAGER:CreateControl("CRT_ALERT_BD",CRT_ALERT_TLW,CT_BACKDROP)
	CRT_ALERT_BD:SetHidden(not CRT.SV.Settings.ALERT.preview)
	CRT_ALERT_BD:SetDimensions( 800 , 300 )
	CRT_ALERT_BD:SetCenterColor(0.1,0.1,0.1,1)
	CRT_ALERT_BD:SetEdgeColor(0,0,0,1)
	CRT_ALERT_BD:SetEdgeTexture("", 8, 1, 1)
	CRT_ALERT_BD:SetAlpha(0.6)
	CRT_ALERT_BD:SetAnchor(TOPLEFT,lsSum,TOPLEFT,0,0)
end

function CRT_ALERT_Update(timestamp)
	local meta = getmetatable(CRT.SV.Craft_data)

		for k, _ in pairs(meta.__index) do 
			if (k ~= "version" and CRT.SV.Craft_data[CRT_Current_Playername]["Start"] == true) then
				local CRT_Current_PlayerPosition = GetMapPlayerPosition("player")
				if (CRT_Current_PlayerPosition ~= CRT_Start_PlayerPosition) then
					CRT.SV.Craft_data[CRT_Current_Playername]["Start"] = false
					CRT_Research_Alert(CRT_Current_Playername, nil, nil, true)
					for k, _ in pairs(meta.__index) do 
						if ((k ~= "version" and k ~= CRT_Current_Playername) and (CRT.SV.Craft_data[k][0]["Simu_craft"] ~= 0 or CRT.SV.Craft_data[k][1]["Simu_craft"] ~= 0 or CRT.SV.Craft_data[k][2]["Simu_craft"] ~= 0)) then
							CRT_Research_Alert(k, nil, nil, true)
						end
					end		
				end
			end
			if (k ~= "version") then
				for id_craft = 0, 2,1 do
					for simcraft = 1, 3,1 do
						if (CRT.SV.Craft_data[k][id_craft][simcraft] ~= nil)then
						local currenttimer = CRT.SV.Craft_data[k][id_craft][simcraft]["EndTimeStamp"] - timestamp - 1

							if (currenttimer <= 0) then
								
								if (CRT.SV.Craft_data[k][id_craft][simcraft]["Alert"] == true) then
									CRT.SV.Craft_data[k][id_craft][simcraft]["Alert"] = false
									CRT_Research_Alert(k, id_craft, simcraft, false)	
								end
							end
						end
					end
				end
			end
		end
end